/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        24.10.2007
 Description:    Webserver
----------------------------------------------------------------------------*/

#include <avr/io.h>

#include "usart.h"
#include "enc28j60.h"
#include "stack.h"
#include "timer.h"
#include "httpd.h"
#include "cmd.h"
#include "telnetd.h"


void test (unsigned char index)
{
	for (int a = TCP_DATA_START_VAR;a < TCP_DATA_END_VAR;a++)
	{
		usart_write("%c",eth_buffer[a]);
	}
	tcp_entry[index].time = TCP_TIME_OFF;
	tcp_entry[index].status = ACK_FLAG;
	create_new_tcp_packet(0,index);
}



//----------------------------------------------------------------------------
//
int main(void)
{  
    myip[0] = 192;
    myip[1] = 168;
    myip[2] = 0;
    myip[3] = 99;
    
	mymac[0] = 0x00;
    mymac[1] = 0x20;
    mymac[2] = 0x18;
    mymac[3] = 0xb1;
    mymac[4] = 0x15;
    mymac[5] = 0x5f;
	
    unsigned long a;

	ETH_INT_ENABLE;
	
    usart_init(9600); // setup the UART
	timer_init(); //Timer starten 
   
	usart_write("\n\rSystem Ready\n\r");

	//Applikationen Eintragen
	httpd_init();
	telnetd_init();
	
	
 	/*ENC Initialisieren*/
    for(a=0;a<1000000;a++){asm("nop");};
	ETH_INIT();
	usart_write("NIC Init Ready\n\r");
    for(a=0;a<1000000;a++){asm("nop");};
	
	usart_write("My IP: %2i.%2i.%2i.%2i\r\n\r\n",myip[0],myip[1],myip[2],myip[3]);
	
	//Globale Interrupts einschalten
	sei(); 
 
	/*
	//offnet eine Verbindung zu meinem Webserver
	usart_write("ARP Request\n\r");
	unsigned long destip;
	destip =(87)+((unsigned long)(106)<<8)+((unsigned long)(58)<<16)+((unsigned long)(153)<<24);
	
	add_tcp_app (1234, (void(*)(unsigned char))test);
	
	//ARP Request senden
	arp_request (destip);
	for(a=0;a<2000000;a++){asm("nop");};
	
	tcp_port_open (destip,LBBL_ENDIAN_INT(80),LBBL_ENDIAN_INT(1234));
	
	unsigned long index = MAX_ARP_ENTRY;
	while((index >= MAX_ARP_ENTRY) && (tcp_entry[index].app_status != 1))
	{
		index = tcp_entry_search (destip,LBBL_ENDIAN_INT(80));
		DEBUG("TCP Eintrag nicht gefunden\r\n");
	}
	DEBUG("TCP Eintrag gefunden !!!\r\n");
	tcp_entry[index].first_ack = 1;
	
	ETH_INT_DISABLE;
	memmove(&eth_buffer[TCP_DATA_START],
			"GET /home/index.php HTTP/1.1\r\nHost: 192.168.0.99\r\nConnection: Keep-Alive\r\n\r\n",76);		
	tcp_entry[index].status =  ACK_FLAG | PSH_FLAG;
	create_new_tcp_packet(76,index);
	ETH_INT_ENABLE;
	*/
 
	while(1)
	{
		if (usart_status.usart_ready)
		{
			if(cmd_exec(&usart_rx_buffer[0]))
			{
				usart_write("Ready\r\n\r\n");
			}
			else
			{
				usart_write("ERROR\r\n\r\n");
			}
			usart_status.usart_ready =0;
		}
    }
		
return(0);
}

